#ifndef __DRAW_H__
#define __DRAW_H__

#include <gtk/gtk.h>

GdkColor make_color(gushort r, gushort g, gushort b);
void get_draw_size(GuiInterface *gui, int *width, int *height);
void draw_area_initialize(GuiInterface *gui);
void draw_point(GuiInterface *gui, Point *pose, int point_size, GdkColor color);
void draw_laser_range(GuiInterface *gui,
		      LaserRangeData *laser, LocalizerParticle *pose);
void show_draw_area(GuiInterface *gui);

void draw_pointmap(PointMap *pmap, GuiInterface *gui);
void draw_particle(GuiInterface *gui,
		   LocalizerParticle *particle,
		   int point_size,
		   GdkColor particle_color,
		   GdkColor vector_color);
void draw_particles(GuiInterface *gui,
		    LocalizerParticle *particles,
		    int n, int point_size);

#endif /* __DRAW_H__ */
